git-rebase.shon commit rebase --merge: return control to caller, for housekeeping (01a1e64)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_SPEC="\
   9git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  11git-rebase --continue | --abort | --skip | --edit-todo
  12--
  13 Available options are
  14v,verbose!         display a diffstat of what changed upstream
  15q,quiet!           be quiet. implies --no-stat
  16onto=!             rebase onto given branch instead of upstream
  17p,preserve-merges! try to recreate merges instead of ignoring them
  18s,strategy=!       use the given merge strategy
  19no-ff!             cherry-pick all commits, even if unchanged
  20m,merge!           use merging strategies to rebase
  21i,interactive!     let the user edit the list of commits to rebase
  22x,exec=!           add exec lines after each commit of the editable list
  23k,keep-empty       preserve empty commits during rebase
  24f,force-rebase!    force rebase even if branch is up to date
  25X,strategy-option=! pass the argument through to the merge strategy
  26stat!              display a diffstat of what changed upstream
  27n,no-stat!         do not show diffstat of what changed upstream
  28verify             allow pre-rebase hook to run
  29rerere-autoupdate  allow rerere to update index with resolved conflicts
  30root!              rebase all reachable commits up to the root(s)
  31autosquash         move commits that begin with squash!/fixup! under -i
  32committer-date-is-author-date! passed to 'git am'
  33ignore-date!       passed to 'git am'
  34whitespace=!       passed to 'git apply'
  35ignore-whitespace! passed to 'git apply'
  36C=!                passed to 'git apply'
  37 Actions:
  38continue!          continue
  39abort!             abort and check out the original branch
  40skip!              skip current patch and continue
  41edit-todo!         edit the todo list during an interactive rebase
  42"
  43. git-sh-setup
  44. git-sh-i18n
  45set_reflog_action rebase
  46require_work_tree_exists
  47cd_to_toplevel
  48
  49LF='
  50'
  51ok_to_skip_pre_rebase=
  52resolvemsg="
  53$(gettext 'When you have resolved this problem, run "git rebase --continue".
  54If you prefer to skip this patch, run "git rebase --skip" instead.
  55To check out the original branch and stop rebasing, run "git rebase --abort".')
  56"
  57unset onto
  58cmd=
  59strategy=
  60strategy_opts=
  61do_merge=
  62merge_dir="$GIT_DIR"/rebase-merge
  63apply_dir="$GIT_DIR"/rebase-apply
  64verbose=
  65diffstat=
  66test "$(git config --bool rebase.stat)" = true && diffstat=t
  67git_am_opt=
  68rebase_root=
  69force_rebase=
  70allow_rerere_autoupdate=
  71# Non-empty if a rebase was in progress when 'git rebase' was invoked
  72in_progress=
  73# One of {am, merge, interactive}
  74type=
  75# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  76state_dir=
  77# One of {'', continue, skip, abort}, as parsed from command line
  78action=
  79preserve_merges=
  80autosquash=
  81keep_empty=
  82test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  83
  84read_basic_state () {
  85        head_name=$(cat "$state_dir"/head-name) &&
  86        onto=$(cat "$state_dir"/onto) &&
  87        # We always write to orig-head, but interactive rebase used to write to
  88        # head. Fall back to reading from head to cover for the case that the
  89        # user upgraded git with an ongoing interactive rebase.
  90        if test -f "$state_dir"/orig-head
  91        then
  92                orig_head=$(cat "$state_dir"/orig-head)
  93        else
  94                orig_head=$(cat "$state_dir"/head)
  95        fi &&
  96        GIT_QUIET=$(cat "$state_dir"/quiet) &&
  97        test -f "$state_dir"/verbose && verbose=t
  98        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
  99        test -f "$state_dir"/strategy_opts &&
 100                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 101        test -f "$state_dir"/allow_rerere_autoupdate &&
 102                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 103}
 104
 105write_basic_state () {
 106        echo "$head_name" > "$state_dir"/head-name &&
 107        echo "$onto" > "$state_dir"/onto &&
 108        echo "$orig_head" > "$state_dir"/orig-head &&
 109        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 110        test t = "$verbose" && : > "$state_dir"/verbose
 111        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 112        test -n "$strategy_opts" && echo "$strategy_opts" > \
 113                "$state_dir"/strategy_opts
 114        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 115                "$state_dir"/allow_rerere_autoupdate
 116}
 117
 118output () {
 119        case "$verbose" in
 120        '')
 121                output=$("$@" 2>&1 )
 122                status=$?
 123                test $status != 0 && printf "%s\n" "$output"
 124                return $status
 125                ;;
 126        *)
 127                "$@"
 128                ;;
 129        esac
 130}
 131
 132move_to_original_branch () {
 133        case "$head_name" in
 134        refs/*)
 135                message="rebase finished: $head_name onto $onto"
 136                git update-ref -m "$message" \
 137                        $head_name $(git rev-parse HEAD) $orig_head &&
 138                git symbolic-ref \
 139                        -m "rebase finished: returning to $head_name" \
 140                        HEAD $head_name ||
 141                die "$(gettext "Could not move back to $head_name")"
 142                ;;
 143        esac
 144}
 145
 146run_specific_rebase () {
 147        if [ "$interactive_rebase" = implied ]; then
 148                GIT_EDITOR=:
 149                export GIT_EDITOR
 150                autosquash=
 151        fi
 152        . git-rebase--$type
 153        ret=$?
 154        if test $ret -eq 0
 155        then
 156                git gc --auto &&
 157                rm -rf "$state_dir"
 158        fi
 159        exit $ret
 160}
 161
 162run_pre_rebase_hook () {
 163        if test -z "$ok_to_skip_pre_rebase" &&
 164           test -x "$GIT_DIR/hooks/pre-rebase"
 165        then
 166                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 167                die "$(gettext "The pre-rebase hook refused to rebase.")"
 168        fi
 169}
 170
 171test -f "$apply_dir"/applying &&
 172        die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
 173
 174if test -d "$apply_dir"
 175then
 176        type=am
 177        state_dir="$apply_dir"
 178elif test -d "$merge_dir"
 179then
 180        if test -f "$merge_dir"/interactive
 181        then
 182                type=interactive
 183                interactive_rebase=explicit
 184        else
 185                type=merge
 186        fi
 187        state_dir="$merge_dir"
 188fi
 189test -n "$type" && in_progress=t
 190
 191total_argc=$#
 192while test $# != 0
 193do
 194        case "$1" in
 195        --no-verify)
 196                ok_to_skip_pre_rebase=yes
 197                ;;
 198        --verify)
 199                ok_to_skip_pre_rebase=
 200                ;;
 201        --continue|--skip|--abort|--edit-todo)
 202                test $total_argc -eq 2 || usage
 203                action=${1##--}
 204                ;;
 205        --onto)
 206                test 2 -le "$#" || usage
 207                onto="$2"
 208                shift
 209                ;;
 210        -x)
 211                test 2 -le "$#" || usage
 212                cmd="${cmd}exec $2${LF}"
 213                shift
 214                ;;
 215        -i)
 216                interactive_rebase=explicit
 217                ;;
 218        -k)
 219                keep_empty=yes
 220                ;;
 221        -p)
 222                preserve_merges=t
 223                test -z "$interactive_rebase" && interactive_rebase=implied
 224                ;;
 225        --autosquash)
 226                autosquash=t
 227                ;;
 228        --no-autosquash)
 229                autosquash=
 230                ;;
 231        -M|-m)
 232                do_merge=t
 233                ;;
 234        -X)
 235                shift
 236                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
 237                do_merge=t
 238                test -z "$strategy" && strategy=recursive
 239                ;;
 240        -s)
 241                shift
 242                strategy="$1"
 243                do_merge=t
 244                ;;
 245        -n)
 246                diffstat=
 247                ;;
 248        --stat)
 249                diffstat=t
 250                ;;
 251        -v)
 252                verbose=t
 253                diffstat=t
 254                GIT_QUIET=
 255                ;;
 256        -q)
 257                GIT_QUIET=t
 258                git_am_opt="$git_am_opt -q"
 259                verbose=
 260                diffstat=
 261                ;;
 262        --whitespace)
 263                shift
 264                git_am_opt="$git_am_opt --whitespace=$1"
 265                case "$1" in
 266                fix|strip)
 267                        force_rebase=t
 268                        ;;
 269                esac
 270                ;;
 271        --ignore-whitespace)
 272                git_am_opt="$git_am_opt $1"
 273                ;;
 274        --committer-date-is-author-date|--ignore-date)
 275                git_am_opt="$git_am_opt $1"
 276                force_rebase=t
 277                ;;
 278        -C)
 279                shift
 280                git_am_opt="$git_am_opt -C$1"
 281                ;;
 282        --root)
 283                rebase_root=t
 284                ;;
 285        -f|--no-ff)
 286                force_rebase=t
 287                ;;
 288        --rerere-autoupdate|--no-rerere-autoupdate)
 289                allow_rerere_autoupdate="$1"
 290                ;;
 291        --)
 292                shift
 293                break
 294                ;;
 295        esac
 296        shift
 297done
 298test $# -gt 2 && usage
 299
 300if test -n "$cmd" &&
 301   test "$interactive_rebase" != explicit
 302then
 303        die "$(gettext "The --exec option must be used with the --interactive option")"
 304fi
 305
 306if test -n "$action"
 307then
 308        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 309        # Only interactive rebase uses detailed reflog messages
 310        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 311        then
 312                GIT_REFLOG_ACTION="rebase -i ($action)"
 313                export GIT_REFLOG_ACTION
 314        fi
 315fi
 316
 317if test "$action" = "edit-todo" && test "$type" != "interactive"
 318then
 319        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 320fi
 321
 322case "$action" in
 323continue)
 324        # Sanity check
 325        git rev-parse --verify HEAD >/dev/null ||
 326                die "$(gettext "Cannot read HEAD")"
 327        git update-index --ignore-submodules --refresh &&
 328        git diff-files --quiet --ignore-submodules || {
 329                echo "$(gettext "You must edit all merge conflicts and then
 330mark them as resolved using git add")"
 331                exit 1
 332        }
 333        read_basic_state
 334        run_specific_rebase
 335        ;;
 336skip)
 337        output git reset --hard HEAD || exit $?
 338        read_basic_state
 339        run_specific_rebase
 340        ;;
 341abort)
 342        git rerere clear
 343        read_basic_state
 344        case "$head_name" in
 345        refs/*)
 346                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 347                die "$(eval_gettext "Could not move back to \$head_name")"
 348                ;;
 349        esac
 350        output git reset --hard $orig_head
 351        rm -r "$state_dir"
 352        exit
 353        ;;
 354edit-todo)
 355        run_specific_rebase
 356        ;;
 357esac
 358
 359# Make sure no rebase is in progress
 360if test -n "$in_progress"
 361then
 362        state_dir_base=${state_dir##*/}
 363        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 364        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 365        die "
 366$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 367I wonder if you are in the middle of another rebase.  If that is the
 368case, please try
 369        $cmd_live_rebase
 370If that is not the case, please
 371        $cmd_clear_stale_rebase
 372and run me again.  I am stopping in case you still have something
 373valuable there.')"
 374fi
 375
 376if test -n "$rebase_root" && test -z "$onto"
 377then
 378        test -z "$interactive_rebase" && interactive_rebase=implied
 379fi
 380
 381if test -n "$interactive_rebase"
 382then
 383        type=interactive
 384        state_dir="$merge_dir"
 385elif test -n "$do_merge"
 386then
 387        type=merge
 388        state_dir="$merge_dir"
 389else
 390        type=am
 391        state_dir="$apply_dir"
 392fi
 393
 394if test -z "$rebase_root"
 395then
 396        case "$#" in
 397        0)
 398                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 399                        --verify -q @{upstream} 2>/dev/null)
 400                then
 401                        . git-parse-remote
 402                        error_on_missing_default_upstream "rebase" "rebase" \
 403                                "against" "git rebase <branch>"
 404                fi
 405                ;;
 406        *)      upstream_name="$1"
 407                shift
 408                ;;
 409        esac
 410        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 411        die "$(eval_gettext "invalid upstream \$upstream_name")"
 412        upstream_arg="$upstream_name"
 413else
 414        if test -z "$onto"
 415        then
 416                empty_tree=`git hash-object -t tree /dev/null`
 417                onto=`git commit-tree $empty_tree </dev/null`
 418                squash_onto="$onto"
 419        fi
 420        unset upstream_name
 421        unset upstream
 422        test $# -gt 1 && usage
 423        upstream_arg=--root
 424fi
 425
 426# Make sure the branch to rebase onto is valid.
 427onto_name=${onto-"$upstream_name"}
 428case "$onto_name" in
 429*...*)
 430        if      left=${onto_name%...*} right=${onto_name#*...} &&
 431                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 432        then
 433                case "$onto" in
 434                ?*"$LF"?*)
 435                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 436                        ;;
 437                '')
 438                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 439                        ;;
 440                esac
 441        else
 442                die "$(eval_gettext "\$onto_name: there is no merge base")"
 443        fi
 444        ;;
 445*)
 446        onto=$(git rev-parse --verify "${onto_name}^0") ||
 447        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 448        ;;
 449esac
 450
 451# If the branch to rebase is given, that is the branch we will rebase
 452# $branch_name -- branch being rebased, or HEAD (already detached)
 453# $orig_head -- commit object name of tip of the branch before rebasing
 454# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 455switch_to=
 456case "$#" in
 4571)
 458        # Is it "rebase other $branchname" or "rebase other $commit"?
 459        branch_name="$1"
 460        switch_to="$1"
 461
 462        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 463           orig_head=$(git rev-parse -q --verify "refs/heads/$1")
 464        then
 465                head_name="refs/heads/$1"
 466        elif orig_head=$(git rev-parse -q --verify "$1")
 467        then
 468                head_name="detached HEAD"
 469        else
 470                die "$(eval_gettext "fatal: no such branch: \$branch_name")"
 471        fi
 472        ;;
 4730)
 474        # Do not need to switch branches, we are already on it.
 475        if branch_name=`git symbolic-ref -q HEAD`
 476        then
 477                head_name=$branch_name
 478                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 479        else
 480                head_name="detached HEAD"
 481                branch_name=HEAD ;# detached
 482        fi
 483        orig_head=$(git rev-parse --verify HEAD) || exit
 484        ;;
 485*)
 486        die "BUG: unexpected number of arguments left to parse"
 487        ;;
 488esac
 489
 490require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 491
 492# Now we are rebasing commits $upstream..$orig_head (or with --root,
 493# everything leading up to $orig_head) on top of $onto
 494
 495# Check if we are already based on $onto with linear history,
 496# but this should be done only when upstream and onto are the same
 497# and if this is not an interactive rebase.
 498mb=$(git merge-base "$onto" "$orig_head")
 499if test "$type" != interactive && test "$upstream" = "$onto" &&
 500        test "$mb" = "$onto" &&
 501        # linear history?
 502        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 503then
 504        if test -z "$force_rebase"
 505        then
 506                # Lazily switch to the target branch if needed...
 507                test -z "$switch_to" || git checkout "$switch_to" --
 508                say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 509                exit 0
 510        else
 511                say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 512        fi
 513fi
 514
 515# If a hook exists, give it a chance to interrupt
 516run_pre_rebase_hook "$upstream_arg" "$@"
 517
 518if test -n "$diffstat"
 519then
 520        if test -n "$verbose"
 521        then
 522                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 523        fi
 524        # We want color (if set), but no pager
 525        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 526fi
 527
 528test "$type" = interactive && run_specific_rebase
 529
 530# Detach HEAD and reset the tree
 531say "$(gettext "First, rewinding head to replay your work on top of it...")"
 532git checkout -q "$onto^0" || die "could not detach HEAD"
 533git update-ref ORIG_HEAD $orig_head
 534
 535# If the $onto is a proper descendant of the tip of the branch, then
 536# we just fast-forwarded.
 537if test "$mb" = "$orig_head"
 538then
 539        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 540        move_to_original_branch
 541        exit 0
 542fi
 543
 544if test -n "$rebase_root"
 545then
 546        revisions="$onto..$orig_head"
 547else
 548        revisions="$upstream..$orig_head"
 549fi
 550
 551run_specific_rebase